/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello  */
/*                                                                          */
/*                                                                          */
/*                        MODEM7 file name receiver                         */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.210.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU SHOULD  IMMEDIATELY CONTACT THE AUTHORS    */
/*    AT THE  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO    */
/*    USE   THIS  FILE  WITHOUT  HAVING   ACCEPTED  THE  TERMS  OF   THE    */
/*    BINKLEYTERM  LICENSING AGREEMENT,  OR SUCH OTHER  AGREEMENT AS YOU    */
/*    ARE ABLE TO REACH WITH THE AUTHORS.                                   */
/*                                                                          */
/*                                                                          */
/*    The Authors can be reached at the following addresses:                */
/*                                                                          */
/*    Robert C. Hartman                      Vincent E. Perriello           */
/*    Spark Software                         VEP Software                   */
/*    427-3 Amherst Street                   111 Carroll Street             */
/*    CS2032, Suite 232                      Naugatuck, CT 06770            */
/*    Nashua, NH 03061                                                      */
/*                                                                          */
/*    FidoNet 1:132/101                      FidoNet 1:141/491              */
/*    Data    (603) 888-8179                 Data    (203) 729-7569         */
/*                                                                          */
/*    Please feel free to contact us at any time to share your comments     */
/*    about our software and/or licensing policies.                         */
/*                                                                          */
/*                                                                          */
/*  This module is based largely on a similar module in OPUS-CBCS V1.03b.   */
/*  The original work is (C) Copyright 1987, Wynn Wagner III. The original  */
/*  author has graciously allowed us to use his code in this work.          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <conio.h>

#ifdef __TURBOC__
#include <mem.h>
#else
#include <memory.h>
#endif

#include "com.h"
#include "xfer.h"
#include "zmodem.h"
#include "keybd.h"
#include "sbuf.h"
#include "sched.h"
#include "externs.h"
#include "prototyp.h"

/* ------------------------------------------------------------------------ */
/* TeLink batch mode file name mini-header                                  */
/* ------------------------------------------------------------------------ */
int recvmdm7 (fname)
char *fname;
{
   register int i, j;
   int got_dot;
   int retbyte;
   int tries;
   int xchksum;
   int got_eot;
   char *stat = NOTHING_msg;
   char tempname[30];

   XON_DISABLE ();                               /* ww */

   if (fullscreen && un_attended)
      {
      sb_move (filewin, 2, 2);
      }
   else
      {
      set_xy ("");
      }

   tries = got_eot = 0;

   if (PEEKBYTE () == (int) 0xffff)
      SENDBYTE (NAK);


top:

   message (NULL);

   if (fullscreen && un_attended)
      {
      sb_move (filewin, 2, 2);
      sb_puts (filewin, "                  ");
      sb_show ();
      }

   i = got_dot = 0;
   tries++;

   memset (tempname, '\0', 30);
   memset (fname, '\0', 30);

   while ((CARRIER) && (tries < 8))
      {
      switch (retbyte = TIMED_READ (3))
         {
         case SUB:
            /*--------------------------------------------*/
            /* SUB                                        */
            /*--------------------------------------------*/
            if (!i)
               {
               if (tries < 4)
                  goto top;
               else
                  {
                  return (0);
                  }
               }

            for (xchksum = SUB, i = 0; tempname[i]; i++)
               xchksum += tempname[i];
            CLEAR_INBOUND ();
            SENDBYTE ((unsigned char) (xchksum & 0xff));
            retbyte = TIMED_READ (5);
            if (retbyte == ACK)
               {
               /*---- Gussy up the name ---------------*/
               memset (fname, '\0', 30);
               for (
                    i = j = got_dot = 0;
                    ((tempname[i]) && (i < 30));
                    i++
                  )
                  {
                  if (tempname[i] == '.')
                     got_dot = 1;
                  else if ((i == 8) && (!got_dot))
                     fname[j++] = '.';
                  fname[j++] = tempname[i];
                  }

               /* force BBS_STATUS to overwrite line */
               message (NULL);
               return 1;
               }

            got_eot = 0;
            SENDBYTE (NAK);
            goto top;

         case 'u':                              /* Another error condition */
         case ACK:
            /*--------------------------------------------*/
            /* ACK                                        */
            /*--------------------------------------------*/
            goto top;

         case EOT:
            /*--------------------------------------------*/
            /* EOT                                        */
            /*--------------------------------------------*/
            stat = EOT_msg;
            SENDBYTE (ACK);
            if (got_eot > 2)
               return 0;

            got_eot++;
            goto top;

         case CAN:
            /*--------------------------------------------*/
            /* CAN                                        */
            /*--------------------------------------------*/
            stat = CAN_msg;
            goto fubar;

         default:
            /*--------------------------------------------*/
            /* Default                                    */
            /*--------------------------------------------*/
            if (retbyte < ' ')
               {
               if (got_eot > 2)
                  return 0;
               else got_eot++;

               CLEAR_INBOUND ();

               SENDBYTE (NAK);
               goto top;
               }
            if (i >= 30)
               {
               stat = _s_mdm7toolong;
               goto fubar;
               }
            if ((retbyte >= ' ') && (retbyte <= '~'))
               {
               tempname[i++] = (char) retbyte;
               if (fullscreen && un_attended)
                  {
                  sb_putc (filewin, (unsigned char) (retbyte & 0xff));
                  sb_show ();
                  }
               else
                  {
                  putch (retbyte);
                  }
               }
            SENDBYTE (ACK);
         }                                       /* switch */
      }                                          /* while */

fubar:

   if (tries >= 16)
      stat = FUBAR_msg;
   message (stat);

   return 0;
}                                                /* get batchname */

/* END OF FILE: recvmdm7.c */
